<?php
/**
 * Zikula Application Framework
 *
 * @copyright (c) 2008, Pawel Preneta <jusuff@jabster.pl>
 * @link http://code.zikula.org/bianor/
 * @version $Id: pnadminapi.php 203 2009-12-28 12:25:01Z jusuff $
 * @license GNU/GPL - http://www.gnu.org/copyleft/gpl.html
 * @package menutree
 */

function menutree_adminapi_gettemplates()
{
    $dom = ZLanguage::getModuleDomain('menutree');
    Loader::loadClass('FileUtil');
    $templates = array();
    $tpls = array();
    // restricted templates, array for possible future changes
    $sysTpls = array('menutree_block_menutree_modify.htm');
    // module templates
    $modulesTpls = FileUtil::getFiles('modules/menutree/pntemplates', false, true, 'htm', false);
    $configTpls = FileUtil::getFiles('config/templates/menutree', false, true, 'htm', false);
    $tpls['modules'] = array_merge($modulesTpls,$configTpls);

    // themes templates - get user and admin themes
    $userThemes = ThemeUtil::getAllThemes(PNTHEME_FILTER_USER);
    $adminThemes = ThemeUtil::getAllThemes(PNTHEME_FILTER_ADMIN);
    $themesTpls = array();
    foreach($userThemes as $ut) {
        $themesTpls[$ut['name']] = FileUtil::getFiles('themes/'.$ut['name'].'/templates/modules/menutree/', false, true, 'htm', false);
    }
    foreach($adminThemes as $at) {
        if(!array_key_exists($at['name'],$themesTpls)) {
            $themesTpls[$at['name']] = FileUtil::getFiles('themes/'.$at['name'].'/templates/modules/menutree/', false, true, 'htm', false);
        }
    }

    // get tpls which exist in every theme
    $tpls['themes']['all'] = call_user_func_array('array_intersect', $themesTpls);

    // get tpls which exist in some themes
    $tpls['themes']['some'] = array_unique(call_user_func_array('array_merge', $themesTpls));
    $tpls['themes']['some'] = array_diff($tpls['themes']['some'],$tpls['themes']['all'],$tpls['modules'],$sysTpls);

    $templates = array_unique(array_merge($tpls['modules'],$tpls['themes']['all']));
    $templates = array_diff($templates,$sysTpls);
    sort($templates);
    // fill array keys using values
    $templates = array_combine($templates, $templates);

    $someThemes = __('Only in some themes',$dom);
    if(!empty($tpls['themes']['some'])) {
        sort($tpls['themes']['some']);
        $templates[$someThemes] = array_combine($tpls['themes']['some'],$tpls['themes']['some']);
    }

    return $templates;
}

function menutree_adminapi_getstylesheets()
{
    $dom = ZLanguage::getModuleDomain('menutree');
    Loader::loadClass('FileUtil');
    $stylesheets = array();
    $styles = array();
    // restricted stylesheets, array for possible future changes
    $sysStyles = array('adminstyle.css','contextmenu.css','style.css');
    // module stylesheets
    $modulesStyles = FileUtil::getFiles('modules/menutree/pnstyle', false, false, 'css', false);
    $configStyles = FileUtil::getFiles('config/styles/menutree', false, false, 'css', false);
    $styles['modules'] = array_merge($modulesStyles,$configStyles);

    // themes stylesheets - get user and admin themes
    $userThemes = ThemeUtil::getAllThemes(PNTHEME_FILTER_USER);
    $adminThemes = ThemeUtil::getAllThemes(PNTHEME_FILTER_ADMIN);
    $themesStyles = array();
    foreach($userThemes as $ut) {
        $themesStyles[$ut['name']] = FileUtil::getFiles('themes/'.$ut['name'].'/style/menutree', false, false, 'css', false);
    }
    foreach($adminThemes as $at) {
        if(!array_key_exists($at['name'],$themesStyles)) {
            $themesStyles[$ut['name']] = FileUtil::getFiles('themes/'.$at['name'].'/style/menutree', false, false, 'css', false);
        }
    }

    // get stylesheets which exist in every theme
    $styles['themes']['all'] = call_user_func_array('array_intersect', $themesStyles);

    // get stylesheets which exist in some themes
    $styles['themes']['some'] = array_unique(call_user_func_array('array_merge', $themesStyles));
    $styles['themes']['some'] = array_diff($styles['themes']['some'],$styles['themes']['all'],$styles['modules'],$sysStyles);

    $stylesheets = array_unique(array_merge($styles['modules'],$styles['themes']['all']));
    $stylesheets = array_diff($stylesheets,$sysStyles);
    sort($stylesheets);
    // fill array keys using values
    $stylesheets = array_combine($stylesheets, $stylesheets);

    $someThemes = __('Only in some themes',$dom);
    if(!empty($styles['themes']['some'])) {
        sort($styles['themes']['some']);
        $stylesheets[$someThemes] = array_combine($styles['themes']['some'],$styles['themes']['some']);
    }

    return $stylesheets;
}
