<?php
/**
 * Zikula Application Framework
 *
 * @copyright (c) 2008, Pawel Preneta <jusuff@jabster.pl>
 * @link http://code.zikula.org/bianor/
 * @version $Id: pninit.php 172 2009-11-04 01:18:22Z jusuff $
 * @license GNU/GPL - http://www.gnu.org/copyleft/gpl.html
 * @package menutree
 */


function menutree_init()
{
    return true;
}

function menutree_upgrade($oldversion)
{
    // Upgrade dependent on old version number
    switch($oldversion) {
        //initial versions - for postnuke 764 i 800
        case '0.1':
        case '1.0':
            $_menus = pnBlocksGetInfo();
            foreach($_menus as $menu) {
                if($menu['bkey'] == 'menutree') {
                    $menuVars = pnBlockVarsFromContent($menu['content']);
                    $lang = !empty($menu['language']) ? $menu['language'] : pnUserGetLang();
                    $oldMenu = unserialize($menuVars['menutree_content']);
                    $menuVars['menutree_content'] = array();
                    foreach($oldMenu as $k => $v) {
                        $v = unserialize($v);
                        $v = array_merge($v, array('state' => 1,'lang' => $lang));
                        $menuVars['menutree_content'][$k][$lang] = $v;
                    }
                    $menu['content'] = pnBlockVarsToContent($menuVars);
                    pnModAPIFunc('Blocks', 'admin', 'update', $menu);
                }
            }
            break;
        case '2.0':
        case '2.0.1':
        case '2.1':
                $_menus = pnBlocksGetInfo();
                foreach($_menus as $menu) {
                    if($menu['bkey'] == 'menutree') {
                        // need to rewrite lang codes for block titles, oldlanguages prop, olddefaultlang prop and menu items
                        $menuVars = pnBlockVarsFromContent($menu['content']);
                        // first block titles
                        foreach ($menuVars['menutree_titles'] as $l3 => $val) {
                            if ($l2 = ZLanguage::translateLegacyCode($l3)) {
                                unset($menuVars['menutree_titles'][$l3]);
                                $menuVars['menutree_titles'][$l2] = $val;
                            }
                        }
                        // now oldlanguages prop
                        $oldlanguages = array();
                        foreach ($menuVars['oldlanguages'] as $l3) {
                            if ($l2 = ZLanguage::translateLegacyCode($l3)) {
                                $oldlanguages[] = $l2;
                            }
                        }
                        $menuVars['oldlanguages'] = $oldlanguages;
                        // now olddefaultanguage prop
                        if ($l2 = ZLanguage::translateLegacyCode($menuVars['olddefaultanguage'])) {
                            $menuVars['olddefaultanguage'] = $l2;
                        } else {
                            $menuVars['olddefaultanguage'] = 'en';
                        }
                        // and last but not least menu items
                        foreach($menuVars['menutree_content'] as $key => $items) {
                            foreach($items as $l3 => $val) {
                                if ($l2 = ZLanguage::translateLegacyCode($l3)) {
                                    unset($menuVars['menutree_content'][$key][$l3]);
                                    $val['lang'] = $l2;
                                    $menuVars['menutree_content'][$key][$l2] = $val;
                                }
                            }
                        }
                        $menu['content'] = pnBlockVarsToContent($menuVars);
                        pnModAPIFunc('Blocks', 'admin', 'update', $menu);
                    }
                }
            break;
    }

    // Update successful
    return true;
}

function menutree_delete()
{
    return true;
}
